package regex ;

public class Matcher3 {
  private Re pat ;
  private String text ;

  // Les recherches commencent  cette position dans text
  private int regStart ;
  // La dernire sous-chane filtre est text[mStart...mEnd[
  private int mStart, mEnd ;

  Matcher3(Re pat, String text) {
    this.pat = pat ; this.text = text ;
    regStart = 0 ;       // Commencer  filtrer  partir du dbut
    mStart = mEnd = -1 ; // Aucun motif encore reconnu
  }

  // Renvoie la dernire sous-chane filtre, si il y a lieu
  public String group() {
    if (mStart == -1) throw new Error("Pas de sous-chane filtre") ;
    return text.substring(mStart, mEnd) ;
  }

  // Mthode de recherche des sous-chanes filtres a peu prs
  // conforme  celle des Matcher3 de java.util.regex
  public boolean find() {
    for (int start = regStart ; start <= text.length() ; start++) {
      int end = Re.back(pat, text, start) ;
      if (end >= 0) {
        mStart = start ; mEnd = end ;
        regStart = mEnd ; // Le prochain find commencera aprs celui-ci
        return true ;
      }
    }
    mStart = mEnd = -1 ; // Pas de sous-chane reconnue
    regStart = 0 ;       // Recommencer au dbut, bizarre
    return false ;
  }
}
